# pxm-vue-components

Set of components useful for developing vuejs projects.

## informations

Version Vuejs : 2.7.7

# Available components

## PxmAutocomplete

<table>
    <tr>
        <th>Props</th>
        <th>Type</th>
        <th>Default</th>
        <th>Description</th>
    </tr>
    <tr>
        <td>value</td>
        <td>any</td>
        <td>undefined</td>
        <td>The value of the input</td>
    </tr>
    <tr>
        <td>valueComparator</td>
        <td>Function</td>
        <td>undefined</td>
        <td>
            Function which will be used if defined to find the correspondence in the data for value<br>
            The function has as parameter an object array containing the index, the object itself and the label displayed<br>
            It must return an object from the array provided as a parameter
        </td>
    </tr>
    <tr>
        <td>items</td>
        <td>Array</td>
        <td>[]</td>
        <td>Data list</td>
    </tr>
    <tr>
        <td>label</td>
        <td>String</td>
        <td>''</td>
        <td>The autocomplete label</td>
    </tr>
    <tr>
        <td>itemText</td>
        <td>String | Function</td>
        <td>'text'</td>
        <td>
            Allows you to define the text in the option<br>
            Maybe a thong. It is possible to reach the deep value of an object via several attributes separated by "."<br>
            A function can be used and receives as parameter an object with several values such as index and item.
        </td>
    </tr>
    <tr>
        <td>itemValue</td>
        <td>String | Function</td>
        <td>undefined</td>
        <td>
            Allows you to set the return value when an option is selected<br>
            If not defined is undefined and therefore returns an object with the index of the element and the object itself<br>
            Maybe a thong. It is possible to reach the deep value of an object via several attributes separated by "."<br>
            A function can be used and receives as parameter an object with several values such as index and item.<br>
            This is not taken into account if "returnObject" is active
        </td>
    </tr>
    <tr>
        <td>returnObject</td>
        <td>Boolean</td>
        <td>false</td>
        <td>If true returns object as value</td>
    </tr>
    <tr>
        <td>hideSelected</td>
        <td>Boolean</td>
        <td>false</td>
        <td>Allows you not to display items already selected in the selection menu</td>
    </tr>
    <tr>
        <td>caseSensitive</td>
        <td>Boolean</td>
        <td>false</td>
        <td>Allows you to make the options filter case sensitive</td>
    </tr>
    <tr>
        <td>id</td>
        <td>String</td>
        <td>''</td>
        <td>Sets the DOM identifier on the component</td>
    </tr>
    <tr>
        <td>noItemsText</td>
        <td>String</td>
        <td>'No items'</td>
        <td>Allows you to define the text to display when there is no data</td>
    </tr>
    <tr>
        <td>hideNoItems</td>
        <td>Boolean</td>
        <td>false</td>
        <td>Hides the menu when there are no options to display</td>
    </tr>
    <tr>
        <td>disabled</td>
        <td>Boolean</td>
        <td>false</td>
        <td>Disable the input field</td>
    </tr>
    <tr>
        <td>hideItemsNoSearch</td>
        <td>Boolean</td>
        <td>false</td>
        <td>
            Hides options if no search is performed<br>
            This is not taken into account if numberStartingSearch > 0
        </td>
    </tr>
    <tr>
        <td>numberStartingSearch</td>
        <td>Number</td>
        <td>0</td>
        <td>Number from which the search begins to display information</td>
    </tr>
    <tr>
        <td>classes</td>
        <td>Object</td>
        <td>{}}</td>
        <td>
            Allows you to add/modify classes in the component<br>
            labelClass => The classes that will be on the label. Default: pxm_autocomplete_label<br>
            inputClass => The classes that will be on the input field. Default: pxm_autocomplete_input<br>
            ulClass => The classes that will be on the ul. Default: pxm_autocomplete_ul<br>
            allLiClass => The classes that will be on each link in the menu. Default: pxm_autocomplete_li<br>
            itemClass => The classes that will be on each options link. Default: pxm_autocomplete_item<br>
            noItemsClass => The classes which will be on the "no data" link. Default: pxm_autocomplete_no_items<br>
            loadingClass => The classes that will be on the loading link. Default: pxm_autocomplete_loading
        </td>
    </tr>
    <tr>
        <td>itemDisplayLimit</td>
        <td>Number</td>
        <td>0</td>
        <td>
            Allows you to display only a certain number of options in the drop-down menu.<br>
            If it is 0 then no limit
        </td>
    </tr>
    <tr>
        <td>desabledArrows</td>
        <td>Boolean</td>
        <td>false</td>
        <td>
            Allows you to disable navigation using the arrows in the drop-down menu.<br>
            Also disables the enter key
        </td>
    </tr>
    <tr>
        <td>clearable</td>
        <td>Boolean</td>
        <td>false</td>
        <td>
            Add an icon to the field when a value is defined or if a search is defined<br>
            Allows you to clean the field by emptying the search and/or the selected option if there is one
        </td>
    </tr>
    <tr>
        <td>clearableIcon</td>
        <td>String | Array</td>
        <td>''</td>
        <td>Allows you to modify the icon of the clearable option</td>
    </tr>
    <tr>
        <td>fontAwesomeIconModule</td>
        <td>Boolean</td>
        <td>false</td>
        <td>Allows you to define the display of icons with the FontAwesomeIcon module if it is active</td>
    </tr>
    <tr>
        <td>notSaveOption</td>
        <td>Boolean</td>
        <td>false</td>
        <td>
            Does not save the selected option and just returns the result<br>
            The search will be cleaned after sending the result
        </td>
    </tr>
    <tr>
        <td>itemSearch</td>
        <td>String | Function</td>
        <td>undefined</td>
        <td>
            Allows you to define the actual label used for the search<br>
            If set, overrides itemText for search<br>
            Maybe a thong. It is possible to reach the deep value of an object via several attributes separated by "."<br>
            A function can be used and receives as parameter an object with several values such as index and item.
        </td>
    </tr>
    <tr>
        <td>tagList</td>
        <td>String</td>
        <td>'ul'</td>
        <td>
            Allows you to change the html tags of the option list<br>
            Available options: ul, div
        </td>
    </tr>
</table>